import { j as s } from "../../node_modules/react/jsx-runtime.mjs";
import { useContext as U, useState as j, useMemo as b } from "react";
import { isMobile as v } from "../../node_modules/react-device-detect/dist/lib.mjs";
import { Table as W, Skeleton as X } from "antd";
import Y from "../BitzDrawer/index.mjs";
import Z from "../BitzLoadMore/index.mjs";
import $ from "../BitzPagination/index.mjs";
import I from "../BitzNoData/index.mjs";
import S from "./ToolBar/index.mjs";
import { Container as ss, TableContext as es } from "./Store/Provide.mjs";
import "./index.less.mjs";
import { columnSort as is, genColumnKey as N } from "./utils/index.mjs";
import ls from "../../node_modules/ahooks/es/useThrottleEffect/index.mjs";
import rs from "../../node_modules/lodash-es/at.mjs";
const ns = ({
  tableItemEmit: a = () => {
  },
  showPagination: B = !0,
  dataSource: i = [],
  total: h = 0,
  columns: o,
  loading: x = !1,
  skeletonNum: w = 2,
  skeletonRender: f,
  skeletonRowNum: M = 4,
  skeletonRowsWidth: g = ["35%", "100%", "100%", "60%"],
  tableOperationEmit: z = () => {
  },
  mobileLoadEmit: y = () => {
  },
  mobileRefreshEmit: T = () => {
  },
  operations: L = [],
  paginationEmit: C = () => {
  },
  mobilePageHeight: k = 500,
  mobileCancelText: u = "取消",
  noDataTitle: E,
  noDataImg: K,
  color: D,
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  size: os,
  pagination: F = !1,
  showTableTool: O = !0,
  tableAction: P,
  tableToolbar: _,
  ...A
}) => {
  const t = U(es), [H, c] = j(!1), [V, q] = j({}), G = b(() => (i == null ? void 0 : i.length) == h && (i == null ? void 0 : i.length) > 0, [i, h]), J = (e) => {
    c(!0), q(e), a(e);
  }, d = () => {
    c(!1);
  }, Q = (e) => {
    c(!1), z(e.type, V);
  }, m = b(() => {
    const e = (r) => r.map((n) => {
      const R = N(n.key || n.dataIndex, n.index), p = t.columnsMap[R];
      return p && p.show === !1 ? !1 : n.children ? {
        ...n,
        children: e(n.children)
      } : n;
    }).filter(Boolean);
    return e(o).sort(is(t.columnsMap));
  }, [t.columnsMap, o]);
  return ls(
    () => {
      if (o && o.length > 0) {
        const e = o.map(
          (l) => (
            // @ts-ignore
            N(l.key ?? l.dataIndex, l == null ? void 0 : l.dataIndex)
          )
        );
        t.setSortKeyColumns(e);
      }
    },
    [o],
    { wait: 100 }
  ), /* @__PURE__ */ s.jsxs("div", { className: "bitzTableBlock", children: [
    !v && /* @__PURE__ */ s.jsxs("div", { className: "bitzTableContainer", children: [
      O && /* @__PURE__ */ s.jsx(S, { tableAction: P, tableToolbar: _ }),
      /* @__PURE__ */ s.jsx(
        W,
        {
          columns: m,
          dataSource: i,
          pagination: F,
          loading: x,
          size: t.tableSize,
          ...A
        }
      ),
      B && /* @__PURE__ */ s.jsx(
        $,
        {
          total: h,
          dataSource: i,
          paginationEmit: C
        }
      )
    ] }),
    v && /* @__PURE__ */ s.jsxs(s.Fragment, { children: [
      (x || (i == null ? void 0 : i.length) > 0) && /* @__PURE__ */ s.jsx(
        Z,
        {
          color: D,
          height: k,
          showNoMore: G,
          refreshEmit: T,
          loadEmit: y,
          extra: /* @__PURE__ */ s.jsxs("div", { className: "mobileTable", children: [
            i == null ? void 0 : i.map((e, l) => /* @__PURE__ */ s.jsxs("div", { children: [
              /* @__PURE__ */ s.jsx("div", { className: "rowBox", children: m == null ? void 0 : m.map((r, n) => /* @__PURE__ */ s.jsx("div", { children: !(r != null && r.mobileHide) && /* @__PURE__ */ s.jsxs(
                "div",
                {
                  className: "row",
                  onClick: () => {
                    J(e);
                  },
                  children: [
                    /* @__PURE__ */ s.jsxs("div", { className: "label", children: [
                      r.title,
                      "："
                    ] }),
                    /* @__PURE__ */ s.jsx("div", { className: "value", children: r.render(
                      rs(e, r == null ? void 0 : r.dataIndex),
                      e,
                      l
                    ) })
                  ]
                }
              ) }, n)) }),
              /* @__PURE__ */ s.jsx("div", { className: "rowBoxLine" })
            ] }, l)),
            x && Array.from({ length: w }).map((e, l) => /* @__PURE__ */ s.jsxs("div", { children: [
              /* @__PURE__ */ s.jsx("div", { className: "rowBox", children: f ? f() : /* @__PURE__ */ s.jsx(
                X,
                {
                  title: !1,
                  paragraph: {
                    rows: M,
                    width: g
                  },
                  active: !0
                }
              ) }),
              /* @__PURE__ */ s.jsx("div", { className: "rowBoxLine" })
            ] }, l)),
            /* @__PURE__ */ s.jsx(
              Y,
              {
                className: "tableMobileDrawer",
                open: H,
                placement: "bottom",
                height: "auto",
                closable: !1,
                onClose: d,
                children: /* @__PURE__ */ s.jsxs("div", { className: "drawerBox", children: [
                  /* @__PURE__ */ s.jsx("div", { className: "boxBody", children: L.map((e, l) => /* @__PURE__ */ s.jsx(
                    "div",
                    {
                      className: "operaList",
                      onClick: () => {
                        Q(e);
                      },
                      children: e.label
                    },
                    l
                  )) }),
                  /* @__PURE__ */ s.jsx("div", { className: "boxLine" }),
                  /* @__PURE__ */ s.jsx("div", { className: "boxFooter", onClick: d, children: u })
                ] })
              }
            )
          ] })
        }
      ),
      !x && /* @__PURE__ */ s.jsx(I, { data: i, title: E, img: K })
    ] })
  ] });
}, ws = (a) => (
  // @ts-ignore
  /* @__PURE__ */ s.jsx(ss, { initValue: a, children: /* @__PURE__ */ s.jsx(ns, { ...a }) })
);
export {
  ws as default
};
